function LongRequest()
{
	this.requests = new Array({"url":"", "data": null, "callback":function(){}});
	
	this._appendRid = function(url, reqId)
	{
		var splitter = "?";
		if(url.indexOf("?") >= 0)
		{
			splitter = "&";
		}
		
		return url+splitter+"LongRequestId="+String(reqId);
	}
	
	this.send = function (url, data, callback)
	{
		// Register request
		var reqId = this.requests.length;
		this.requests[reqId] = { "url":url, "data":data, "callback":callback };
		
		// Create data params
		var datastr = "";
		for(i in data)
		{
			datastr += "&" + i.toString() + "=" + data[i].toString();
		}
		
		
		// Create iframe
		var iframe = document.createElement("iframe");
		iframe.name = iframe.id = "LongRequestIframe_"+String(reqId);
		iframe.src = this._appendRid(url, reqId)+datastr;
		iframe.style.height = iframe.style.width = "1px";
		iframe.style.border = "none";
		iframe.style.display = "none";
		document.body.appendChild(iframe);
	}
	
	this.sendForm = function (url, form, callback)
	{
		// Register request
		var reqId = this.requests.length;
		this.requests[reqId] = { "url":url, "form":form, "callback":callback };
		
		// Save form params
		var targetOrig = form.target;
		var actionOrig = form.action;
		
		// Create iframe
		var iframe = document.createElement("iframe");
		iframe.name = iframe.id = "LongRequestIframe_"+String(reqId);
		iframe.style.height = iframe.style.width = "1px";
		iframe.style.border = "none";
		iframe.style.display = "none";
		document.body.appendChild(iframe);
		
		// Create hidden field
		var field = document.createElement("input");
		field.type = "hidden";
		field.name = "LongRequestId";
		field.value = reqId;
		form.appendChild(field);
		
		// Set up&send form
		form.action = this._appendRid(url, reqId);
		form.target = "LongRequestIframe_"+String(reqId);
		form.submit();
		
		// Restore form params
		form.action = actionOrig;
		form.target = targetOrig;
		form.removeChild(field);
	}
	
	this.callback = function(mode, reqId, jsData, htmlData)
	{
		if(this.requests[reqId].callback != null)
		{
			this.requests[reqId].callback(mode, jsData, htmlData);
		}
	}
}

lreq = new LongRequest();